Summary: Prism II Wireless 802.11b core package
Name: kernel-wlan-ng
Version: 0.2.0
Release: 7
URL: http://www.linux-wlan.com/
Source0: linux-wlan-ng-%{version}.tar.gz
Source1: ifcfg-wlan0
Source2: etc-hotplug-usb-wusb11
Source10: kernel-i386.h
Source11: kernel-i386-smp.h
Source12: kernel-i586.h
Source13: kernel-i586-smp.h
Source14: kernel-i686.h
Source15: kernel-i686-smp.h
Source16: kernel-athlon.h
Source17: kernel-athlon-smp.h
Patch1: wlan-config-generic.patch
License: Dual MPL/GPL
Group: System Environment/Kernel
BuildRoot: /usr/src/redhat/BUILD/wlan-install

%description
The linux-wlan package is a linux device driver and subsystem
package that is intended to provide the full range of IEEE 802.11 MAC
management capabilities for use in user-mode utilities and scripts.
The package currently supports the Intersil 802.11b Prism2, Prism2.5, 
and Prism3 reference designs for PCMCIA, PCI, and USB.  Additionally,
the package includes support for PLX9052 based PCI to PCMCIA adapter
with a few different PCMCIA cards.

This package also provides the documentation files included with the
linux-wlan-ng source code, including LICENSE and configuration 
information.

%package usb
Summary:  Additional stuff for USB users
Requires: kernel-wlan-ng = %{version}, hotplug
Group: System Environment/Kernel

%description usb
This package provides additional, necessary files to enable users
with USB devices to work.  It enables hot-plugging and to date
has only been tested with the Linksys WUSB11.

The linux-wlan package is a linux device driver and subsystem
package that is intended to provide the full range of IEEE 802.11 MAC
management capabilities for use in user-mode utilities and scripts.
The package currently supports the Intersil 802.11b Prism2, Prism2.5, 
and Prism3 reference designs for PCMCIA, PCI, and USB.  Additionally,
the package includes support for PLX9052 based PCI to PCMCIA adapter
with a few different PCMCIA cards.

%package pci
Summary:  Additional stuff for PCI users
Requires: kernel-wlan-ng = %{version}
Group: System Environment/Kernel

%description pci
This package provides additional, necessary files to enable users
with PCI devices to work.  It enables hot-plugging and such...
**IF** you need hotplugging, you must install RedHat's hotplug
package!!!

The linux-wlan package is a linux device driver and subsystem
package that is intended to provide the full range of IEEE 802.11 MAC
management capabilities for use in user-mode utilities and scripts.
The package currently supports the Intersil 802.11b Prism2, Prism2.5, 
and Prism3 reference designs for PCMCIA, PCI, and USB.  Additionally,
the package includes support for PLX9052 based PCI to PCMCIA adapter
with a few different PCMCIA cards.

%package pcmcia
Summary:  Additional stuff for PCMCIA users
Requires: kernel-wlan-ng = %{version}, kernel-pcmcia-cs
Group: System Environment/Kernel

%description pcmcia
This package provides additional, necessary files to enable users
with PCMCIA devices to work.  It fully plugs into Redhat's standard
PCMCIA setup and, after configuration, should work flawlessly...
especially since I'm a PCMCIA user :)

The linux-wlan package is a linux device driver and subsystem
package that is intended to provide the full range of IEEE 802.11 MAC
management capabilities for use in user-mode utilities and scripts.
The package currently supports the Intersil 802.11b Prism2, Prism2.5, 
and Prism3 reference designs for PCMCIA, PCI, and USB.  Additionally,
the package includes support for PLX9052 based PCI to PCMCIA adapter
with a few different PCMCIA cards.

%package modules-%{linvers}
Summary:  Kernel modules for a generic kernel, %{linvers}
Requires: kernel-wlan-ng = %{version}, modutils
Group: System Environment/Kernel

%description modules-%{linvers}
Kernel modules for the pre-compiled kernel RPMS provided by SGI and
RedHat, specifically %{linvers}.  Loadable modules for PCMCIA, USB, 
and PCI versions are provided.  Compiled with PCMCIA-CS version 
%{pcmvers}.

The linux-wlan package is a linux device driver and subsystem
package that is intended to provide the full range of IEEE 802.11 MAC
management capabilities for use in user-mode utilities and scripts.
The package currently supports the Intersil 802.11b Prism2, Prism2.5, 
and Prism3 reference designs for PCMCIA, PCI, and USB.  Additionally,
the package includes support for PLX9052 based PCI to PCMCIA adapter
with a few different PCMCIA cards.

%prep
%setup -q -n linux-wlan-ng-%{version}
%patch1 -p1

###  Here's the tricky part.  Preparing the KERNEL!

###  Provide a non-redhat way out of the kernel prep process...
%ifnarch x86

###  Save the original kernel...but be careful if we are restarting a failed
###  RPM process
if [ -f /usr/src/redhat/BUILD/kernel-system.h ]; then
   echo "Not moving /boot/kernel.h"
else
   install -m 444 /boot/kernel.h /usr/src/redhat/BUILD/kernel-system.h
fi
   
cd /usr/src/linux;
make mrproper

%ifarch i386
   cp -f `ls configs/*-i386.config` .config
   install -m 644 %{SOURCE10} /boot/kernel.h
%endif

%ifarch i386-smp
   cp -f `ls configs/*-i386-smp.config` .config
   install -m 644 %{SOURCE11} /boot/kernel.h
%endif

%ifarch i586
   cp -f `ls configs/*-i586.config` .config
   install -m 644 %{SOURCE12} /boot/kernel.h
%endif

%ifarch i586-smp
   cp -f `ls configs/*-i586-smp.config` .config
   install -m 644 %{SOURCE13} /boot/kernel.h
%endif

%ifarch i686
   cp -f `ls configs/*-i686.config` .config
   install -m 644 %{SOURCE15} /boot/kernel.h
%endif

%ifarch i686-smp
   cp -f `ls configs/*-i686-smp.config` .config
   install -m 644 %{SOURCE16} /boot/kernel.h
%endif

%ifarch athlon
   cp -f `ls configs/*-athlon.config` .config
   install -m 644 %{SOURCE15} /boot/kernel.h
%endif

%ifarch athlon-smp
   cp -f `ls configs/*-athlon-smp.config` .config
   install -m 644 %{SOURCE16} /boot/kernel.h
%endif

make oldconfig
make dep

####  END KERNEL PREP PHASE
%endif

%build
make auto_config
make all

%install
make install

###  Clean up man page installation
cd /usr/src/redhat/BUILD/wlan-install/usr
mkdir -p /usr/src/redhat/BUILD/wlan-install/usr/share
mv -f local/man share
rmdir local

###  Clean up final modules installation
cd /usr/src/redhat/BUILD/wlan-install/lib/modules/2.*
mkdir -p kernel/drivers
mv -f net pcmcia usb kernel/drivers

install -d %buildroot/etc/sysconfig/network-scripts
install %{SOURCE1} %buildroot/etc/sysconfig/network-scripts/ifcfg-wlan0
install -d %buildroot/etc/hotplug/usb
install %{SOURCE1} %buildroot/etc/hotplug/usb/wusb11

%clean
%ifnarch x86
mv -f /usr/src/redhat/BUILD/kernel-system.h /boot/kernel.h
cd /usr/src/linux
make mrproper
%endif
rm -rf $RPM_BUILD_ROOT/*

%files
%defattr(-,root,root)
%config /etc/sysconfig/network-scripts/ifcfg-wlan0
%config /etc/wlan/wlancfg-DEFAULT
%config /etc/wlan/wlan.conf
%config /etc/wlan/shared
%doc CHANGES 
%doc COPYING 
%doc LICENSE 
%doc README 
%doc THANKS 
%doc TODO 
%doc doc 
/sbin/wlanctl-ng
/sbin/wland
/sbin/nwepgen
/sbin/wlancfg
/usr/share/man

%files pcmcia
%defattr(-,root,root)
/etc/pcmcia/wlan-ng
/etc/pcmcia/wlan-ng.conf

%files usb
/etc/rc.d/init.d/wlan
/etc/hotplug/usb

%files pci
/etc/rc.d/init.d/wlan

%files modules-%{linvers}
%defattr(-,root,root)
/lib/modules

%post pcmcia

touch /etc/modules.conf
grep -q wlan /etc/modules.conf
[ $? -ne 0 ] && {
    echo "Adding prism2_cs alias to /etc/modules.conf file..."
    echo "alias wlan0 prism2_cs" >> /etc/modules.conf
}

sed -e 's/ONBOOT=yes/ONBOOT=no/' /etc/sysconfig/network-scripts/ifcfg-wlan0 > /tmp/ifcfg-wlan0
mv -f /tmp/ifcfg-wlan0 /etc/sysconfig/network-scripts
chmod 644 /etc/sysconfig/network-scripts/ifcfg-wlan0

service pcmcia restart

echo "The default wlan0 network configuration is DHCP.  Adjust accordingly."
echo ""
echo "ACHTUNG!  ATTENTION!  WARNING!"
echo "   YOU MUST configure /etc/wlan/wlan.conf to define your SSID!"
echo "   YOU ALSO must configure /etc/wlan/wlancfg-SSID to match WAP settings!"
echo "       (---> replace SSID in filename with the value of your SSID)"
echo ""

%post pci
/sbin/chkconfig wlan on

touch /etc/modules.conf
grep -q wlan /etc/modules.conf
[ $? -ne 0 ] && {
    echo "Adding prism2_pci alias to /etc/modules.conf file..."
    echo "***NOTE***  YOU MUST CHANGE THIS IF YOU HAVE A PLX CARD!!!"
    echo "alias wlan0 prism2_pci" >> /etc/modules.conf
}

echo "The default wlan0 network configuration is DHCP.  Adjust accordingly."
echo ""
echo "ACHTUNG!  ATTENTION!  WARNING!"
echo "   YOU MUST configure /etc/wlan/wlan.conf to define your SSID!"
echo "   YOU ALSO must configure /etc/wlan/wlancfg-SSID to match WAP settings!"
echo "       (---> replace SSID in filename with the value of your SSID)"
echo ""
echo "If you get an error after this point, there is either a problem with "
echo "your drivers or you don't have the hardware installed!  If the former,"
echo "get help!"
echo ""
service wlan start

%post usb
/sbin/chkconfig wlan off

touch /etc/modules.conf
grep -q wlan /etc/modules.conf
[ $? -ne 0 ] && {
    echo "Adding prism2_usb alias to /etc/modules.conf file..."
    echo "options prism2_usb prism2_doreset=1" >> /etc/modules.conf
    echo "alias wlan0 prism2_usb" >> /etc/modules.conf
}

echo "The default wlan0 network configuration is DHCP.  Adjust accordingly."
echo ""
echo "ACHTUNG!  ATTENTION!  WARNING!"
echo "   YOU MUST configure /etc/wlan/wlan.conf to define your SSID!"
echo "   YOU ALSO must configure /etc/wlan/wlancfg-SSID to match WAP settings!"
echo "       (---> replace SSID in filename with the value of your SSID)"
echo ""

%post modules-%{linvers}
depmod -a

%postun modules-%{linvers}
depmod -a

%postun usb
sed -e '/prism2_usb/d' /etc/modules.conf > /tmp/modules.conf
mv /tmp/modules.conf /etc
chmod 644 /etc/modules.conf

%postun pcmcia
sed -e '/prism2_cs/d' /etc/modules.conf > /tmp/modules.conf
mv /tmp/modules.conf /etc
chmod 644 /etc/modules.conf
service pcmcia restart

%preun pci
service wlan stop
chkconfig wlan off

%postun pci
sed -e '/prism2_p/d' /etc/modules.conf > /tmp/modules.conf
mv /tmp/modules.conf /etc
chmod 644 /etc/modules.conf

%changelog
* Sat Apr 12 2003 Tim Miller <millerte@wfu.edu>
- Removed some typos from the spec file..mostly this was the echo'ed statements
  on post-install scripts.

* Thu Apr 10 2003 Tim Miller <millerte@wfu.edu>
- Upgraded source package to 0.2.0.  Given the new configuration file layout
  with the linux-wlan-ng modules, have moved the configuration files into the
  base package (instead of each platform package).  Also, man pages are now
  included in the base package.

* Sun Nov  3 2002 Tim Miller <millerte@wfu.edu>
- Added Athlon kernel support.

* Thu Oct 24 2002 Tim Miller <millerte@wfu.edu>
- Bug fix in PCI module.  The service commands used "on" instead of the
  traditional "start".  No one has complained so possibly that script
  supports on/off as well, but changed it nonetheless.

* Mon Oct 13 2002 Tim Miller <millerte@wfu.edu>
- Bug fix for USB %post script.  Added PCI module loading/unloading in the
  %post and %preun script sections.

* Sat Oct 11 2002 Tim Miller <millerte@wfu.edu>
- Added patch to boost 0.1.15 to 0.1.16pre2 in order to allow compilation
  on RedHat 8.0 systems.  Also switched off "ONBOOT" for the PCMCIA interface
  package.

* Wed Oct  2 2002 Tim Miller <millerte@wfu.edu>
- Oops.  In the %post of PCI, I do not try to load the drivers.  I
  should, although it will generate more questions when there are errors.

* Sun Sep 15 2002 Tim Miller <millerte@wfu.edu>
- Have done the unthinkable:  in order to be able to build i386, i586, and
  i686 modules (along with their unsupported SMP counterparts), I've hacked
  up the spec file to actually go into the kernel source directory and 
  force the Redhat kernel config process to use the correct config file AND
  change the /boot/kernel.h in the process.  Oy vey!

* Sat Sep 14 2002 Tim Miller <millerte@wfu.edu>
- Upgraded source to 0.1.15!  Upped the release version to 5!  More patch
  removal this time (no more reverting the kernel version detection) and
  the /sbin path patch made it into 0.1.15.  So, the only patch I have left
  is the one I use locally to configure the source for RPM building!  Cool!

  The -doc package was removed and several packages were re-arranged in order
  to separate out different actions for different users.  For example, the
  /etc/wlan.conf is now ONLY included in PCI and USB packages.  The PCMCIA
  package is the only one with /etc/pcmcia stuff in it.

  As a side note, there are still some software additions...which will remain
  until a kind USB user will tell me whether they are needed or not.  A short
  summary is that 0.1.15 now supports the hotplug feature in USB and PCI.
  A recently added (to my RPMS) hotplug script was taking care of that for
  WUSB11, but I don't know if it is needed anymore since 0.1.15 supports
  hotplugging.


* Mon Aug 26 2002 Tim Miller <millerte@wfu.edu>
- Added patch to correct the lack of /sbin in patch of rc.wlan script.
  Notice and patch provided by David S Johnson.

* Sun Jul 21 2002 Tim Miller <millerte@wfu.edu>
- Upgraded source to 0.1.14!  This has required the removal of 3 patches
  which have now made it into the wlan-ng source (only one was mine I think).
  The following additional changes also had to be made:
     1.  The kernel version detection in 0.1.14 Configure script has changed.
         As a result, RedHat built kernels (or more specifically, the Redhat
         kernel-source RPM) now reports a multiple line kernel version.  
         I've created a patch which reverses this change in Configure back
         to the 0.1.13 method of doing things.

* Tue Jun 25 2002 Tim Miller <tim.miller@vanderbilt.edu>
- CRAP!  Redhat upped the Wireless Extensions version from 12 to 13 when
  going from 2.4.18-3 to 2.4.18-5.  As a result, the SIOCSIWNAME define
  changed to SIOCSIWCOMMIT.  So, I had to create a patch for prism2wext.c.
  Upped release number to 4.

* Tue Jun 25 2002 Tim Miller <tim.miller@vanderbilt.edu>
- Integrated Erick Calder's modifications for better USB support and
  moved his ifcfg-wlan0 to the main package...not just USB.  

* Mon Apr 29 2002 Tim Miller <tim.miller@vanderbilt.edu>
- Removed the unnecessary patches from the SRPMS.

* Sat Apr 27 2002 Tim Miller <tim.miller@vanderbilt.edu>
- Heh...just read the RPM web site HOWTO and realized there were %config 
  and %doc macros.  Increased release to 3.

* Wed Apr 24 2002 Tim Miller <tim.miller@vanderbilt.edu>
- Added doc package so that the wlan-ng configuration and LICENSE information
  is provided...increased release number to 2.

* Sat Apr 20 2002 Tim Miller <tim.miller@vanderbilt.edu>
- PCMCIA TARGET ROOT bug that occurs in 'make config' does not occur in
  'make auto_config'.  Removed patch3 from prep section.

* Sat Apr 20 2002 Tim Miller <tim.miller@vanderbilt.edu>
- Modified the RH72 and RH72+SGI module builds to be completely generic
  with appropriate macro defines when RPM is called.

* Sat Apr 20 2002 Tim Miller <tim.miller@vanderbilt.edu>
- SPEC file created under GPL v2

